try (fileIn "RW_Material.ms") catch ()
try (fileIn "GTA_Material.ms") catch ()

dffExportPath = undefined
fn batchExport objects = (
	if dffExportPath == undefined then
		dffExportPath = getSavePath()
	else
		dffExportPath = getSavePath initialDir:dffExportPath
	
	fn rootOf obj = (
		while obj.parent != undefined do obj = obj.parent
		obj
	)
	
	exportObjects = #()
	for o in objects do appendIfUnique exportObjects (rootOf o)
	
	showprompt = true
	for o in exportObjects do (
		select o
		print o
		dffpath = dffExportPath + "\\" + o.name + ".dff"
		print ("exporting " + dffpath)
		if showprompt then
			exportFile dffpath using:RenderWare_modelExporterPlugin
		else
			exportFile dffpath #noprompt using:RenderWare_modelExporterPlugin
		showprompt = false
	)
	select objects
)


fn RwToKam m = (
	if (classof m) == Multimaterial do (
		for i = 1 to m.materialList.count do
			m.materialList[i] = RwToKam m.materialList[i]
		return m
	)
	if (classof m) != RW_Mtl do
		return m
	kam = GTA_Mtl()
	kam.amb = m.sp_ambient
	kam.spc = m.sp_specular
	kam.dif = m.sp_diffuse
	kam.color = m.color
	kam.colormap = m.texmap_texture
	kam.use_colormap = kam.colormap != undefined
	kam.alpha = m.coloralpha*255
-- 	kam.alphamap 
-- 	kam.use_alphamap
	kam.use_RF = m.matfxeffect == 3
	kam.Reflection = m.envmap_amount*100
	kam.reflectionmap = m.texmap_envmap
	kam.use_reflectionmap = kam.reflectionmap != undefined

	kam.use_SAS = m.enSpec
-- 	kam.specular
	kam.specularmap = m.specMap
	kam.use_specularmap = kam.specularmap != undefined

	kam.use_SI = m.enEnv
-- 	kam.spec_alpha
 	kam.spec_power = m.specularity*100
	kam.blend = m.shininess*100
	kam
)

utility GtaHelper "GTA helper" (
	button convMat "RW to GTA materials" width:140 align:#center
	button batchExp "Batch Export Selected" width:140 align:#center
	on convMat pressed do ( 
		for o in objects do (
			o.material = RwToKam o.material
		)
	)
	on batchExp pressed do ( 
		batchExport (selection as array)
	)
)